<template lang="html">
  <div class="databaseInfoVue">
    <div class="title">
      <input type="text" name="" value="" class="searchInput" spellcheck="false" placeholder="数据库" v-model="dbName" @keydown.enter="getServer()">
      <div class="right">
        <button type="button" class="btn1" @click="popup.databaseAdd = true">新建</button>
        <button type="button" class="btn1" @click="del()">删除</button>
      </div>
    </div>
    <div class="table">
      <table>
        <tr>
          <td>编号</td>
          <td>数据库名</td>
          <td>地址</td>
          <td>端口</td>
          <td>渠道</td>
          <td>功能</td>
          <td>数据库类型</td>
          <td>是否分表</td>
          <td>分表种类</td>
          <td>详情</td>
          <td>标记</td>
        </tr>
        <tr v-for="n,i in DatabaseData.data">
          <td>{{ i + 1 + (page - 1) * 10 }}.</td>
          <td>
            <p class="lengthLimit">{{ n.dbName }}</p>
          </td>
          <td>{{ n.dbHost }}</td>
          <td>{{ n.dbPort }}</td>
          <td>{{ n.pt }}</td>
          <td>{{ n.effect }}</td>
          <td>{{ n.dbType }}</td>
          <td>
            <span :class="{'tableTrue': n.table}">{{ n.table ? '✔' : '✖' }}</span>
          </td>
          <td>{{ n.tableKind }}</td>
          <td>
            <button type="button" class="btn2" @click="popup.databaseDetails = true, childrenData = n">详情</button>
          </td>
          <td>
            <label :for="'checkbox' + i" class="checkbox">
              <input type="checkbox" name="" value="" :id="'checkbox' + i" v-model="checkbox[i]">
              <span></span>
            </label>
          </td>
        </tr>
        <tr class="empty" v-for="n,i in freeList">
          <td><!-- 编号 --></td>
          <td><!-- 数据库名 --></td>
          <td><!-- 地址 --></td>
          <td><!-- 端口 --></td>
          <td><!-- 渠道 --></td>
          <td><!-- 功能 --></td>
          <td><!-- 数据库类型 --></td>
          <td><!-- 是否分表 --></td>
          <td><!-- 分表种类 --></td>
          <td><!-- 详情 --></td>
          <td><!-- 标记 --></td>
        </tr>
      </table>
      <div class="pageList">
        <div @click="page = page - 1 < 1 ? 1 : page - 1">Provious</div>
        <div @click="page = n" :class="{ 'active': page === n }" v-for="n,i in pageList">{{ n }}</div>
        <div @click="page = page + 1 > pages ? pages : page + 1">Next</div> / 总共 {{ DatabaseData.pageCount || 1 }} 页
      </div>
    </div>

    <!-- 检测模板详情 -->
    <div class="mask" v-if="popup.databaseDetails">
      <database-details @close="popup.databaseDetails = false" :children-data="childrenData"  @update="getServer()" :param-data="paramData" />
    </div>

    <!-- 删除模板 -->
    <div class="mask" v-if="popup.databaseDelete">
      <database-delete @close="popup.databaseDelete = false"  @update="getServer()" :checked-database="checkedDatabase" @clear-checkbox="clearCheckbox()" />
    </div>

    <!-- 新建模板 -->
    <div class="mask" v-if="popup.databaseAdd">
      <database-add @close="popup.databaseAdd = false" :userInfo="userInfo" @update="getServer()" :param-data="paramData" />
    </div>

  </div>
</template>

<script>
import databaseDetails from '@/components/module/databaseDetails'
import databaseDelete from '@/components/module/databaseDelete'
import databaseAdd from '@/components/module/databaseAdd'
import { bus, requestGetServer, requestStartTmp, requestStopTmp, requestGetParam } from '@/vuex/request.js'
import { getPageList } from '@/assets/js/get-page-list.js'

export default {
  components: {
    databaseDetails,
    databaseDelete,
    databaseAdd
  },
  data () {
    return {
      page: 0,
      pages: 7,
      pageList: [1],
      popup: {
        databaseDetails: false,
        databaseDelete: false,
        databaseAdd: false
      },
      checkbox: [false, false, false, false, false, false, false, false, false, false],
      dbName: '',
      DatabaseData: {},
      freeList: 10,
      pageSize: 10,
      childrenData: {},
      checkedDatabase: [],
      paramData: []
    }
  },
  props: ['userInfo'],
  mounted () {
    this.page = 1
    this.getParamData()
  },
  methods: {
    getParamData () {
      requestGetParam((response) => {
        if (response.data) {
          if (response.data.state) {
            this.paramData = response.data.data
          } else {
            bus.$emit('alert', response.data.message)
          }
        } else {
          bus.$emit('alert', response + '.')
        }
      })
    },
    clearCheckbox () {
      this.checkbox = [false, false, false, false, false, false, false, false, false, false]
    },
    tempToggle (i) {
      let data = {
        templateId: this.DatabaseData.data[i].templateId
      }
      if (!this.toggle[i]) {
        requestStartTmp({}, data, (response) => {
          if (response.data) {
            if (response.data.state) {
              this.getServer()
            } else {
              bus.$emit('alert', response.data.message)
            }
          } else {
            bus.$emit('alert', response + '.')
          }
        })
      } else {
        requestStopTmp({}, data, (response) => {
          if (response.data) {
            if (response.data.state) {
              this.getServer()
            } else {
              bus.$emit('alert', response.data.message)
            }
          } else {
            bus.$emit('alert', response + '.')
          }
        })
      }
    },
    del () {
      if (!this.checkbox.some((n, i) => { return n === true })) {
        bus.$emit('alert', '您没有选择任何选项！')
      } else {
        this.popup.databaseDelete = true
        this.checkedDatabase = []
        this.checkbox.forEach((n, i) => {
          if (n) {
            this.checkedDatabase.push(this.DatabaseData.data[i])
          }
        })
      }
    },
    getServer () {
      let pageSize = this.pageSize
      let data = {
        pageNo: this.page,
        pageSize: pageSize,
        dbName: this.dbName
      }
      requestGetServer({}, data, (response) => {
        if (response.data) {
          if (response.data.state) {
            this.DatabaseData = response.data.data
            this.pages = response.data.data.pageCount
            this.pageList = getPageList({
              displayCount: 7,  // 显示的页面总数（最大值）
              page: Math.max(this.page, 1),    // 当前页面
              pages: Math.max(response.data.data.pageCount, 1)    // 总页数
            })
            this.freeList = this.page === response.data.data.pageCount ? pageSize - (response.data.data.dataCount % pageSize === 0 ? pageSize : response.data.data.dataCount % pageSize) : 0
            if (!response.data.data.data.length) {
              this.freeList = 10
            }
          } else {
            bus.$emit('alert', response.data.message)
          }
        } else {
          bus.$emit('alert', response + '.')
        }
      })
    }
  },
  watch: {
    page (val, oldVal) {
      this.getServer()
    }
  }
}
</script>

<style lang="scss" scoped>
.databaseInfoVue{
  padding: 0 50px;
  max-width: 1600px;
  margin: auto;
  .title{
    padding: 15px 0;
    .right{
      float: right;
      height: 100%;
      vertical-align: middle;
      text-align: right;
      line-height: 36px;
      button:nth-of-type(n + 2){
        margin-left: 10px;
      }
    }
  }
}
.tableTrue{
  // display: inline-block;
  // transform: scale(1.5);
  color: #49b0f7;
}
.pageList{
  margin-top: 30px;
  margin-bottom: 10px;
}
</style>
